diff --git a/common/src/main/scala/services/teamwork/SquadService.scala b/common/src/main/scala/services/teamwork/SquadService.scala
index 2c22886c..b837e7a1 100644
--- a/common/src/main/scala/services/teamwork/SquadService.scala
+++ b/common/src/main/scala/services/teamwork/SquadService.scala
@@ -1685,15 +1841,32 @@ class SquadService extends Actor {
         queuedInvites.update(id, filteredQueue)
       }
     }
-    squadFeatures(squadGUID).SearchForRole match {
+    squadFeatures(sguid).ProxyInvites = Nil
+    squadFeatures(sguid).SearchForRole match {
       case None => ;
       case Some(_) =>
-        squadFeatures(squadGUID).SearchForRole = None
+        squadFeatures(sguid).SearchForRole = None
+    }
+    continueToMonitorDetails.collect {
+      case (charId, guid) if sguid == guid =>
+        continueToMonitorDetails.remove(charId)
     }
   }
 
-  def CleanupInvitesFromPlayer(charId : Long) : Unit = {
-    invites.remove(charId)
+  /**
+    * Remove all active and inactive invitation objects that are related to the particular player.
+    * Specifically used to safely disarm obsolete invitation objects by specific criteria.
+    * Affects all invitation object types and all data structures that deal with the player.
+    * @see `RequestRole`
+    * @see `IndirectInvite`
+    * @see `LookingForSquadRoleInvite`
+    * @see `RemoveInvite`
+    * @see `RemoveProximityInvites`
+    * @see `VacancyInvite`
+    * @param charId the player's unique identifier number
+    */
+  def RemoveAllInvitesWithPlayer(charId : Long) : Unit = {
+    RemoveInvite(charId)
     invites.collect {
       case (id, SpontaneousInvite(player)) if player.CharId == charId =>
         RemoveInvite(id)
@@ -1701,11 +1874,9 @@ class SquadService extends Actor {
         RemoveInvite(id)
       case (id, IndirectInvite(player, _)) if player.CharId == charId =>
         RemoveInvite(id)
-      case (id, InviteForRole(_charId, _, _, _)) if _charId == charId =>
+      case (id, LookingForSquadRoleInvite(_charId, _, _, _)) if _charId == charId =>
         RemoveInvite(id)
-      case (id, BidForRole(player, _, _)) if player.CharId == charId =>
-        RemoveInvite(id)
-      case (id, ProximityInvite(_charId, _, _)) if charId == _charId =>
+      case (id, RequestRole(player, _, _)) if player.CharId == charId =>
         RemoveInvite(id)
     }
     //tidy the queued invitations
@@ -1715,9 +1886,8 @@ class SquadService extends Actor {
         case SpontaneousInvite(player) => player.CharId == charId
         case VacancyInvite(player, _, _) => player == charId
         case IndirectInvite(player, _) => player.CharId == charId
-        case InviteForRole(player, _, _, _) => player == charId
-        case BidForRole(player, _, _) => player.CharId == charId
-        case ProximityInvite(_charId, _, _) => _charId == charId
+        case LookingForSquadRoleInvite(player, _, _, _) => player == charId
+        case RequestRole(player, _, _) => player.CharId == charId
         case _ => false
       }
       if(filteredQueue.isEmpty) {
@@ -1727,33 +1897,589 @@ class SquadService extends Actor {
         queuedInvites.update(id, filteredQueue)
       }
     }
-    previousInvites.remove(charId)
+    continueToMonitorDetails.remove(charId)
+    RemoveProximityInvites(charId)
   }
 
-  def CleanupInvitesToPosition(position : Int) : Unit = {
-    invites.collect {
-      case (id, InviteForRole(_, _, _, _position)) if _position == position =>
+  /**
+    * Remove all active and inactive proximity squad invites related to the recruiter.
+    * @see `RemoveProximityInvites(Iterable[(Long, PlanetSideGUID)])`
+    * @param invitingPlayer the player who did the recruiting
+    * @return a list of all players (unique character identifier number and name) who had active proximity invitations
+    */
+  def RemoveProximityInvites(invitingPlayer : Long) : Iterable[(Long, String)] = {
+    //invites
+    val (removedInvites, out) = invites.collect {
+      case (id, ProximityInvite(inviterCharId, inviterName, squadGUID)) if inviterCharId == invitingPlayer =>
         RemoveInvite(id)
-      case (id, BidForRole(_, _, _position)) if _position == position =>
-        RemoveInvite(id)
-    }
-    //tidy the queued invitations
-    queuedInvites.foreach { case(id, queue) =>
-      val filteredQueue = queue.filterNot {
-        case InviteForRole(_, _, _, _position) => _position == position
-        case BidForRole(_, _, _position) => _position == position
+        ((id, squadGUID), (id, inviterName))
+    }.unzip
+    RemoveProximityInvites(removedInvites)
+    //queued
+    RemoveProximityInvites(queuedInvites.flatMap { case (id : Long, inviteList) =>
+      val (outList, inList) = inviteList.partition {
+        case ProximityInvite(inviterCharId, _, _) if inviterCharId == invitingPlayer => true
         case _ => false
       }
-      if(filteredQueue.isEmpty) {
+      if(inList.isEmpty) {
         queuedInvites.remove(id)
       }
-      else if(filteredQueue.size != queue.size) {
-        queuedInvites.update(id, filteredQueue)
+      else {
+        queuedInvites(id) = inList
+      }
+      outList.collect { case ProximityInvite(_, _, sguid : PlanetSideGUID) => id -> sguid }
+    })
+    out.toSeq.distinct
+  }
+
+  /**
+    * Remove all queued proximity squad invite information retained by the squad object.
+    * @see `RemoveProximityInvites(Long)`
+    * @see `SquadFeatures.ProxyInvites`
+    * @see `SquadFeatures.SearchForRole`
+    * @param list a list of players to squads with expected entry redundancy
+    */
+  def RemoveProximityInvites(list : Iterable[(Long, PlanetSideGUID)]) : Unit = {
+    val (ids, squads) = list.unzip
+    squads.toSeq.distinct.foreach { squad =>
+      squadFeatures.get(squad) match {
+        case Some(features) =>
+          val out = list.collect { case (id, sguid) if sguid == squad => id } .toSeq
+          if((features.ProxyInvites = features.ProxyInvites filterNot out.contains) isEmpty) {
+            features.SearchForRole = None
+          }
+        case _ => ;
       }
     }
   }
 
-  def SwapMemberPosition(squad : Squad, toMember : Member, fromMember : Member) : Unit = {
+  /**
+    * Remove all active and inactive proximity squad invites for a specific squad.
+    * @param guid the squad
+    * @return a list of all players (unique character identifier number and name) who had active proximity invitations
+    */
+  def RemoveProximityInvites(guid : PlanetSideGUID) : Iterable[(Long, String)] = {
+    //invites
+    val (removedInvites, out) = invites.collect {
+      case (id, ProximityInvite(_, inviterName, squadGUID)) if squadGUID == guid =>
+        RemoveInvite(id)
+        (squadGUID, (id, inviterName))
+    }.unzip
+    removedInvites.foreach { sguid =>
+      squadFeatures(sguid).ProxyInvites = Nil
+      squadFeatures(sguid).SearchForRole = None
+    }
+    //queued
+    queuedInvites.flatMap { case (id : Long, inviteList) =>
+      val (outList, inList) = inviteList.partition {
+        case ProximityInvite(_, _, squadGUID) if squadGUID == guid => true
+        case _ => false
+      }
+      if(inList.isEmpty) {
+        queuedInvites.remove(id)
+      }
+      else {
+        queuedInvites(id) = inList
+      }
+      outList.collect { case ProximityInvite(_, _, sguid : PlanetSideGUID) =>
+        squadFeatures(sguid).ProxyInvites = Nil
+        squadFeatures(sguid).SearchForRole = None
+      }
+    }
+    out.toSeq.distinct
+  }
+
+  /**
+    * Resolve an invitation to a general, not guaranteed, position in someone else's squad.
+    * For the moment, just validate the provided parameters and confirm the eligibility of the user.
+    * @see `VacancyInvite`
+    * @param squad_guid the unique squad identifier number
+    * @param invitedPlayer the unique character identifier for the player being invited
+    * @param invitingPlayer the unique character identifier for the player who invited the former
+    * @param recruit the player being invited
+    * @return the squad object and a role position index, if properly invited;
+    *         `None`, otherwise
+    */
+  def HandleVacancyInvite(squad_guid : PlanetSideGUID, invitedPlayer : Long, invitingPlayer : Long, recruit : Player) : Option[(Squad, Int)] = {
+    squadFeatures.get(squad_guid) match {
+      case Some(features) =>
+        val squad = features.Squad
+        memberToSquad.get(invitedPlayer) match {
+          case Some(enrolledSquad) =>
+            if(enrolledSquad eq squad) {
+              log.warn(s"HandleVacancyInvite: ${recruit.Name} is already a member of squad ${squad.Task}")
+            }
+            else {
+              log.warn(s"HandleVacancyInvite: ${recruit.Name} is a member of squad ${enrolledSquad.Task} and can not join squad ${squad.Task}")
+            }
+            None
+          case _ =>
+            HandleVacancyInvite(squad, invitedPlayer, invitingPlayer, recruit)
+        }
+
+      case _ =>
+        log.warn(s"HandleVacancyInvite: the squad #${squad_guid.guid} no longer exists")
+        None
+    }
+  }
+
+  /**
+    * Resolve an invitation to a general, not guaranteed, position in someone else's squad.<br>
+    * <br>
+    * Originally, the instigating type of invitation object was a "`VacancyInvite`"
+    * which indicated a type of undirected invitation extended from the squad leader to another player
+    * but the resolution is generalized enough to suffice for a number of invitation objects.
+    * First, an actual position is determined;
+    * then, the squad is tested for recruitment conditions,
+    * including whether the person who solicited the would-be member is still the squad leader.
+    * If the recruitment is manual and the squad leader is not the same as the recruiting player,
+    * then the real squad leader is sent an indirect query regarding the player's eligibility.
+    * These `IndirectInvite` invitation objects also are handled by calls to `HandleVacancyInvite`.
+    * @see `AltAddInviteAndRespond`
+    * @see `IndirectInvite`
+    * @see `SquadFeatures::AutoApproveInvitationRequests`
+    * @see `VacancyInvite`
+    * @see `ValidOpenSquadPosition`
+    * @param squad the squad
+    * @param invitedPlayer the unique character identifier for the player being invited
+    * @param invitingPlayer the unique character identifier for the player who invited the former
+    * @param recruit the player being invited
+    * @return the squad object and a role position index, if properly invited;
+    *         `None`, otherwise
+    */
+  def HandleVacancyInvite(squad : Squad, invitedPlayer : Long, invitingPlayer : Long, recruit : Player) : Option[(Squad, Int)] = {
+    //accepted an invitation to join an existing squad
+    squad.Membership.zipWithIndex.find({ case (member, index) =>
+      ValidOpenSquadPosition(squad, index, member, recruit.Certifications)
+    }) match {
+      case Some((_, line)) =>
+        //position in squad found
+        val sguid = squad.GUID
+        val features = squadFeatures(sguid)
+        if(!features.AutoApproveInvitationRequests && squad.Leader.CharId != invitingPlayer) {
+          //the inviting player was not the squad leader and this decision should be bounced off the squad leader
+          AltAddInviteAndRespond(
+            squad.Leader.CharId,
+            IndirectInvite(recruit, sguid),
+            invitingPlayer,
+            name = ""
+          )
+          debug(s"HandleVacancyInvite: ${recruit.Name} must await an invitation from the leader of squad ${squad.Task}")
+          None
+        }
+        else {
+          Some((squad, line))
+        }
+      case _ =>
+        None
+    }
+  }
+
+  /**
+    * An overloaded entry point to the functionality for handling one player requesting a specific squad role.
+    * @param bid a specific kind of `Invitation` object
+    * @param player the player who wants to join the squad
+    * @return `true`, if the player is not denied the possibility of joining the squad;
+    *        `false`, otherwise, of it the squad does not exist
+    */
+  def HandleRequestRole(bid : RequestRole, player : Player) : Boolean = {
+    HandleRequestRole(bid, bid.squad_guid, player)
+  }
+
+  /**
+    * An overloaded entry point to the functionality for handling indirection when messaging the squad leader about an invite.
+    * @param bid a specific kind of `Invitation` object
+    * @param player the player who wants to join the squad
+    * @return `true`, if the player is not denied the possibility of joining the squad;
+    *        `false`, otherwise, of it the squad does not exist
+    */
+  def HandleRequestRole(bid : IndirectInvite, player : Player) : Boolean = {
+    HandleRequestRole(bid, bid.squad_guid, player)
+  }
+
+  /**
+    * The functionality for handling indirection
+    * for handling one player requesting a specific squad role
+    * or when messaging the squad leader about an invite.<br>
+    * <br>
+    * At this point in the squad join process, the only consent required is that of the squad leader.
+    * An automatic consent flag exists on the squad;
+    * but, if that is not set, then the squad leader must be asked whether or not to accept or to reject the recruit.
+    * If the squad leader changes in the middle of the latter half of the process,
+    * the invitation may still fail even if the old squad leader accepts.
+    * If the squad leader changes in the middle of the latter half of the process,
+    * the inquiry might be posed again of the new squad leader, of whether to accept or to reject the recruit.
+    * @param bid the `Invitation` object that was the target of this request
+    * @param guid the unique squad identifier number
+    * @param player the player who wants to join the squad
+    * @return `true`, if the player is not denied the possibility of joining the squad;
+    *        `false`, otherwise, of it the squad does not exist
+    */
+  def HandleRequestRole(bid : Invitation, guid : PlanetSideGUID, player : Player) : Boolean = {
+    squadFeatures.get(guid) match {
+      case Some(features) =>
+        val leaderCharId = features.Squad.Leader.CharId
+        if(features.AutoApproveInvitationRequests) {
+          self ! SquadServiceMessage(player, Zone.Nowhere, SquadAction.Membership(SquadRequestType.Accept, leaderCharId, None, "", None))
+        }
+        else {
+          import scala.concurrent.duration._
+          import scala.concurrent.ExecutionContext.Implicits.global
+          features.Prompt = context.system.scheduler.schedule(1 milliseconds, 45000 milliseconds, self, SquadResponse.WantsSquadPosition(leaderCharId, player.Name))
+        }
+        true
+      case _ =>
+        //squad is missing
+        log.error(s"Attempted to process ${bid.InviterName}'s bid for a position in a squad that does not exist")
+        false
+    }
+  }
+
+  /**
+    * Pertains to the original message of squad synchronicity sent to the squad leader by the server under specific conditions.
+    * The initial formation of a squad of two players is the most common expected situation.
+    * While the underlying flag is normally only set once, its state can be reset and triggered anew if necessary.
+    * @see `Publish`
+    * @see `ResetAll`
+    * @see `SquadResponse.AssociateWithSquad`
+    * @see `SquadResponse.Detail`
+    * @see `SquadService.Detail.Publish`
+    * @param squad the squad
+    */
+  def InitialAssociation(squad : Squad) : Unit = {
+    val guid = squad.GUID
+    if(squadFeatures(guid).InitialAssociation) {
+      squadFeatures(guid).InitialAssociation = false
+      val charId = squad.Leader.CharId
+      Publish(charId, SquadResponse.AssociateWithSquad(guid))
+      Publish(charId, SquadResponse.Detail(guid, SquadService.Detail.Publish(squad)))
+    }
+  }
+
+  /**
+    * Establish a new squad.
+    * Create all of the support structures for the squad and link into them.
+    * At a minimum, by default, the squad needs a squad leader
+    * and a stronger, more exposed connection between the squad and leader needs to be recognized.<br>
+    * <br>
+    * Usually, a squad is created by modifying some aspect of its necessary fields.
+    * The primary necessary fields required for a squad include the squad's task and the squad's zone of operation.
+    * @see `GetNextSquadId`
+    * @see `Squad`
+    * @see `SquadFeatures`
+    * @see `SquadFeatures::Start`
+    * @param player the player who would become the squad leader
+    * @return the squad that has been created
+    */
+  def StartSquad(player : Player) : Squad = {
+    val faction = player.Faction
+    val name = player.Name
+    val squad = new Squad(GetNextSquadId(), faction)
+    val leadPosition = squad.Membership(0)
+    leadPosition.Name = name
+    leadPosition.CharId = player.CharId
+    leadPosition.Health = player.Health
+    leadPosition.Armor = player.Armor
+    leadPosition.Position = player.Position
+    leadPosition.ZoneId = 1
+    squadFeatures += squad.GUID -> new SquadFeatures(squad).Start
+    memberToSquad += squad.Leader.CharId -> squad
+    debug(s"$name-$faction has created a new squad")
+    squad
+  }
+
+  /**
+    * Behaviors and exchanges necessary to complete the fulfilled recruitment process for the squad role.<br>
+    * <br>
+    * This operation is fairly safe to call whenever a player is to be inducted into a squad.
+    * The aforementioned player must have a callback retained in `UserEvents`
+    * and conditions imposed by both the role and the player must be satisfied.
+    * @see `InitialAssociation`
+    * @see `InitSquadDetail`
+    * @see `InitWaypoints`
+    * @see `Publish`
+    * @see `RemoveAllInvitesWithPlayer`
+    * @see `SquadDetail`
+    * @see `SquadInfo`
+    * @see `SquadPositionDetail`
+    * @see `SquadPositionEntry`
+    * @see `SquadResponse.Join`
+    * @see `StatConverter.Health`
+    * @see `UpdateSquadListWhenListed`
+    * @see `ValidOpenSquadPosition`
+    * @param player the new squad member;
+    *               this player is NOT the squad leader
+    * @param squad the squad the player is joining
+    * @param position the squad member role that the player will be filling
+    * @return `true`, if the player joined the squad in some capacity;
+    *         `false`, if the player did not join the squad or is already a squad member
+    */
+  def JoinSquad(player : Player, squad : Squad, position : Int) : Boolean = {
+    val charId = player.CharId
+    val role = squad.Membership(position)
+    if(UserEvents.get(charId).nonEmpty && squad.Leader.CharId != charId && ValidOpenSquadPosition(squad, position, role, player.Certifications)) {
+      role.Name = player.Name
+      role.CharId = charId
+      role.Health = StatConverter.Health(player.Health, player.MaxHealth, min=1, max=64)
+      role.Armor = StatConverter.Health(player.Armor, player.MaxArmor, min=1, max=64)
+      role.Position = player.Position
+      role.ZoneId = 1
+      memberToSquad(charId) = squad
+
+      continueToMonitorDetails.remove(charId)
+      RemoveAllInvitesWithPlayer(charId)
+      InitialAssociation(squad)
+      Publish(charId, SquadResponse.AssociateWithSquad(squad.GUID))
+      val features = squadFeatures(squad.GUID)
+      val size = squad.Size
+      if(size == 2) {
+        //first squad member after leader; both members fully initialize
+        val (memberCharIds, indices) = squad.Membership
+          .zipWithIndex
+          .filterNot { case (member, _) => member.CharId == 0 }
+          .toList
+          .unzip { case (member, index) => (member.CharId, index) }
+        val toChannel = s"/${features.ToChannel}/Squad"
+        memberCharIds.foreach { charId =>
+          SquadEvents.subscribe(UserEvents(charId), toChannel)
+          Publish(charId, SquadResponse.Join(squad, indices, toChannel))
+          InitWaypoints(charId, squad.GUID)
+        }
+        //fully update for all users
+        InitSquadDetail(squad)
+      }
+      else {
+        //joining an active squad; everybody updates differently
+        val updatedIndex = List(position)
+        val toChannel = s"/${features.ToChannel}/Squad"
+        //new member gets full squad UI updates
+        Publish(
+          charId,
+          SquadResponse.Join(
+            squad,
+            squad.Membership.zipWithIndex.collect({ case (member, index) if member.CharId > 0 => index }).toList,
+            toChannel
+          )
+        )
+        //other squad members see new member joining the squad
+        Publish(features.ToChannel, SquadResponse.Join(squad, updatedIndex, ""))
+        InitWaypoints(charId, squad.GUID)
+        InitSquadDetail(squad.GUID, Seq(charId), squad)
+        UpdateSquadDetail(
+          squad.GUID,
+          SquadDetail().Members(List(SquadPositionEntry(position, SquadPositionDetail().CharId(charId).Name(player.Name))))
+        )
+        SquadEvents.subscribe(UserEvents(charId), toChannel)
+      }
+      UpdateSquadListWhenListed(features, SquadInfo().Size(size))
+      true
+    }
+    else {
+      false
+    }
+  }
+
+  /**
+    * Determine whether a player is sufficiently unemployed
+    * and has no grand delusions of being a squad leader.
+    * @see `CloseSquad`
+    * @param charId the player
+    * @return `true`, if the target player possesses no squad or a squad that is suitably nonexistent;
+    *        `false`, otherwise
+    */
+  def EnsureEmptySquad(charId : Long) : Boolean = {
+    memberToSquad.get(charId) match {
+      case None =>
+        true
+      case Some(squad) if squad.Size == 1 =>
+        CloseSquad(squad)
+        true
+      case _ =>
+        log.warn("EnsureEmptySquad: the invited player is already a member of a squad and can not join a second one")
+        false
+    }
+  }
+
+  /**
+    * Behaviors and exchanges necessary to undo the recruitment process for the squad role.
+    * @see `PanicLeaveSquad`
+    * @see `Publish`
+    * @param charId the player
+    * @param squad the squad
+    * @return `true`, if the player, formerly a normal member of the squad, has been ejected from the squad;
+    *        `false`, otherwise
+    */
+  def LeaveSquad(charId : Long, squad : Squad) : Boolean = {
+    val membership = squad.Membership.zipWithIndex
+    membership.find { case (_member, _) => _member.CharId == charId } match {
+      case data @ Some((_, index)) if squad.Leader.CharId != charId =>
+        PanicLeaveSquad(charId, squad, data)
+        //member leaves the squad completely (see PanicSquadLeave)
+        Publish(
+          charId,
+          SquadResponse.Leave(
+            squad,
+            (charId, index) +: membership
+              .collect { case (_member, _index) if _member.CharId > 0 && _member.CharId != charId => (_member.CharId, _index) }
+              .toList
+          )
+        )
+        SquadEvents.unsubscribe(UserEvents(charId), s"/${squadFeatures(squad.GUID).ToChannel}/Squad")
+        true
+      case _ =>
+        false
+    }
+  }
+
+  /**
+    * Behaviors and exchanges necessary to undo the recruitment process for the squad role.<br>
+    * <br>
+    * The complement of the prior `LeaveSquad` method.
+    * This method deals entirely with other squad members observing the given squad member leaving the squad
+    * while the other method handles messaging only for the squad member who is leaving.
+    * The distinction is useful when unsubscribing from this service,
+    * as the `ActorRef` object used to message the player's client is no longer reliable
+    * and has probably ceased to exist.
+    * @see `LeaveSquad`
+    * @see `Publish`
+    * @see `SquadDetail`
+    * @see `SquadInfo`
+    * @see `SquadPositionDetail`
+    * @see `SquadPositionEntry`
+    * @see `SquadResponse.Leave`
+    * @see `UpdateSquadDetail`
+    * @see `UpdateSquadListWhenListed`
+    * @param charId the player
+    * @param squad the squad
+    * @param entry a paired membership role with its index in the squad
+    * @return if a role/index pair is provided
+    */
+  def PanicLeaveSquad(charId : Long, squad : Squad, entry : Option[(Member, Int)]) : Boolean = {
+    entry match {
+      case Some((member, index)) =>
+        val entry = (charId, index)
+        //member leaves the squad completely
+        memberToSquad.remove(charId)
+        member.Name = ""
+        member.CharId = 0
+        //other squad members see the member leaving
+        Publish(squadFeatures(squad.GUID).ToChannel, SquadResponse.Leave(squad, List(entry)))
+        UpdateSquadListWhenListed(squadFeatures(squad.GUID), SquadInfo().Size(squad.Size))
+        UpdateSquadDetail(
+          squad.GUID,
+          SquadDetail().Members(List(SquadPositionEntry(index, SquadPositionDetail().Player(char_id = 0, name = ""))))
+        )
+        true
+      case None =>
+        false
+    }
+  }
+
+  /**
+    * All players are made to leave the squad and the squad will stop existing.
+    * Any member of the squad missing an `ActorRef` object used to message the player's client
+    * will still leave the squad, but will not attempt to send feedback to the said unreachable client.
+    * If the player is in the process of unsubscribing from the service,
+    * the no-messaging pathway is useful to avoid accumulating dead letters.
+    * @see `Publish`
+    * @see `RemoveAllInvitesToSquad`
+    * @see `SquadDetail`
+    * @see `TryResetSquadId`
+    * @see `UpdateSquadList`
+    * @param squad the squad
+    */
+  def CloseSquad(squad : Squad) : Unit = {
+    val guid = squad.GUID
+    RemoveAllInvitesToSquad(guid)
+    val membership = squad.Membership.zipWithIndex
+    val (updateMembers, updateIndices) = membership
+      .collect { case (member, index) if member.CharId > 0 => ((member, member.CharId, index, UserEvents.get(member.CharId)), (member.CharId, index)) }
+      .unzip
+    val updateIndicesList = updateIndices.toList
+    val completelyBlankSquadDetail = SquadDetail().Complete
+    val channel = s"/${squadFeatures(squad.GUID).ToChannel}/Squad"
+    updateMembers
+      .foreach {
+        case (member, charId, _, None) =>
+          memberToSquad.remove(charId)
+          member.Name = ""
+          member.CharId = 0L
+        case (member, charId, index, Some(actor)) =>
+          memberToSquad.remove(charId)
+          member.Name = ""
+          member.CharId = 0L
+          SquadEvents.unsubscribe(actor, channel)
+          Publish(
+            charId,
+            SquadResponse.Leave(
+              squad,
+              updateIndicesList.filterNot { case (_, outIndex) => outIndex == index } :+ (charId, index) //we need to be last
+            )
+          )
+          Publish(charId, SquadResponse.AssociateWithSquad(PlanetSideGUID(0)))
+          Publish(charId, SquadResponse.Detail(PlanetSideGUID(0), completelyBlankSquadDetail))
+      }
+    UpdateSquadListWhenListed(
+      squadFeatures.remove(guid).get.Stop,
+      None
+    )
+    TryResetSquadId()
+  }
+
+  /**
+    * All players are made to leave the squad and the squad will stop existing.
+    * Essentially, perform the same operations as `CloseSquad`
+    * but treat the process as if the squad is being disbanded in terms of messaging.
+    * @see `PanicDisbandSquad`
+    * @see `Publish`
+    * @see `SquadResponse.Membership`
+    * @param squad the squad
+    */
+  def DisbandSquad(squad : Squad) : Unit = {
+    val leader = squad.Leader.CharId
+    PanicDisbandSquad(
+      squad,
+      squad.Membership.collect { case member if member.CharId > 0 && member.CharId != leader => member.CharId }
+    )
+    //the squad is being disbanded, the squad events channel is also going away; use cached character ids
+    Publish(leader, SquadResponse.Membership(SquadResponseType.Disband, 0, 0, leader, None, "", true, Some(None)))
+  }
+
+  /**
+    * All players are made to leave the squad and the squad will stop existing.<br>
+    * <br>
+    * The complement of the prior `DisbandSquad` method.
+    * This method deals entirely with other squad members observing the squad become abandoned.
+    * The distinction is useful when unsubscribing from this service,
+    * as the `ActorRef` object used to message the player's client is no longer reliable
+    * and has probably ceased to exist.
+    * @see `CloseSquad`
+    * @see `DisbandSquad`
+    * @see `Publish`
+    * @see `SquadResponse.Membership`
+    * @param squad the squad
+    * @param membership the unique character identifier numbers of the other squad members
+    * @return if a role/index pair is provided
+    */
+  def PanicDisbandSquad(squad : Squad, membership : Iterable[Long]) : Unit = {
+    CloseSquad(squad)
+    membership.foreach { charId =>
+      Publish(charId, SquadResponse.Membership(SquadResponseType.Disband, 0, 0, charId, None, "", false, Some(None)))
+    }
+  }
+
+  /**
+    * Move one player into one squad role and,
+    * if encountering a player already recruited to the destination role,
+    * swap that other player into the first player's position.
+    * If no encounter, just blank the original role.
+    * @see `AssignSquadMemberToRole`
+    * @see `SelectRoleForYourself`
+    * @param toMember the squad role where the player is being placed
+    * @param fromMember the squad role where the player is being encountered;
+    *                   if a conflicting player is discovered, swap that player into `fromMember`
+    */
+  def SwapMemberPosition(toMember: Member, fromMember: Member) : Unit = {
     val (name, charId, zoneId, pos, health, armor) = (fromMember.Name, fromMember.CharId, fromMember.ZoneId, fromMember.Position, fromMember.Health, fromMember.Armor)
     if(toMember.CharId > 0) {
       fromMember.Name = toMember.Name
